/*
 * unicode.c -- UTF-8 to UTF-32 conversions and various operations
 *
 * Copyright (c) 2013-2022 David Demelier <markand@malikania.fr>
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <assert.h>
#include <errno.h>
#include <stdlib.h>

#include "unicode.h"

#define nelem(x) (sizeof (x) / sizeof *(x))

static int
cmp1(const void *v1, const void *v2)
{
	uint32_t r1 = *(uint32_t *)v1, r2 = *(uint32_t *)v2;

	return r1 - r2;
}

static int
cmp2(const void *v1, const void *v2)
{
	uint32_t r = *(uint32_t *)v1, *p = (uint32_t *)v2;

	if(r >= p[0] && r <= p[1])
		return 0;
	else
		return r - p[0];
}

